import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class JColorMenuItem extends JMenuItem implements ActionListener {
    Color color;

    JColorChooser jcc;

    public JColorMenuItem(Color color, String str) {
	super(str);
	this.color = color;
	this.addActionListener(this);
	this.jcc = null;
    }

    public void paint(Graphics g) {
	super.paint(g);
	
	Rectangle r = new Rectangle();
	r = g.getClipBounds(r);
	g.setColor(color);
	int h = (int)(r.getHeight()-10)/2;
	g.fill3DRect((int)r.getWidth()-14,h,10,10,true);
    }

    public void actionPerformed(ActionEvent e) {
	if (e.getSource() == this) {
	    this.jcc = new JColorChooser(color);
	    JDialog dialog = jcc.createDialog(this, "Color chooser", true, jcc, this, this);
	    dialog.show();
	} else if (e.getActionCommand().equals("OK")) {
	    Color c = jcc.getColor();
	    
	    firePropertyChange("color", this.color, c);
	    this.color = c;
	} 
    }

    public void setColor(Color color) {
	this.color = color;
    }

    public Color getColor() {
	return this.color;
    }
}
